#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

//Information gathered from readelf on the simple executable
//This information can be different on your system. This should be changed accordingly
#define SEG_OFFSET 0x1000
#define SEG_SIZE 0x0e
#define ENTRY_PT 0x1002

void onErr(const char *title) {
    perror(title);
    exit(EXIT_FAILURE);
}

int main() {

    //Open executable file
    int fd;
    if((fd = open("./simple", O_RDONLY)) == -1)
        onErr("open");

    //Map file in memory
    void *segment;
    if((segment = mmap(NULL, SEG_SIZE, PROT_EXEC | PROT_READ, MAP_PRIVATE, fd, SEG_OFFSET)) == MAP_FAILED)
        onErr("mmap");

    getchar();

    //Define a pointer to the _start function
    void (*ptFunc)(void) = segment + (ENTRY_PT - SEG_OFFSET);
    ptFunc();

    munmap(segment, SEG_SIZE);

    close(fd);

}
