#!/bin/bash
# Usage:
#   generate-pdf.sh url outdir
#
#   url is the url of the course menu file
#   outdir is a folder which will contain the pdfs

URL=$1
OUTDIR=$2

# TODO: check arguments

if [ ! -e "${OUTDIR}" ]; then
    mkdir -p  "${OUTDIR}"
elif [ ! -d "${OUTDIR}"]; then
    echo "${OUTDIR} is not a directory" 1>&2
    exit
fi

SUBLINKS=$(wget -O - "${URL}/menu.html" | awk -F '"' '{print $4}' | grep / | cut -d '/' -f2-)

for SL in ${SUBLINKS}; do
    FILEOUT=$(basename "${SL}")
    FILEOUT="${FILEOUT}.pdf"
    echo "---- Converting ${SL} to ${FILEOUT} ----"
    chromium --headless --run-all-compositor-stages-before-draw --virtual-time-budget=10000 --print-to-pdf="${OUTDIR}/${FILEOUT}" "${URL}/${SL}?print-pdf"
done

